Summary: A SOCKS server for SOCKS4 and SOCKS5
Name: antinat
Version: 0.66
Release: 1
License: GPL
URL: http://yallara.cs.rmit.edu.au/~malsmith/products/antinat/
Packager: Malcolm Smith <malxau@users.sourceforge.net>
Group: Daemons
Source: %{name}-%{version}.tar.bz2
# I'm serious this time, 1.4 or die
Requires: libds >= 1.4.0
BuildRequires: libds-devel >= 1.4.0
Buildroot: %{_tmppath}/%{name}-%{version}-%{release}-root

%description
A SOCKS server for SOCKS4 and SOCKS5

%clean
rm -fR $RPM_BUILD_ROOT

%prep
%setup -q

%build
export CXXFLAGS="-O2"
%configure --datadir=%{_libdir} --with-ipv6
make

%install
%makeinstall datadir=$RPM_BUILD_ROOT%{_libdir}
rm -f `find $RPM_BUILD_ROOT%{_libdir} -name *.a`
rm -f `find $RPM_BUILD_ROOT%{_libdir} -name *.la`
#strip `find $RPM_BUILD_ROOT%{_libdir} -name *.so`
#strip $RPM_BUILD_ROOT%{_bindir}/antinat

%files
%defattr(-,root,root)
%doc COPYING README TODO
%config(noreplace) %{_sysconfdir}/antinat.conf
%{_bindir}/*
%{_mandir}/*
%{_libdir}/antinat-%{version}/address/libipv4_addr.so
%{_libdir}/antinat-%{version}/version5/authenticators/libunpw.so
%{_libdir}/antinat-%{version}/version5/authenticators/unpwsources
%{_libdir}/antinat-%{version}/version5/commands/libv5conn.so
%{_libdir}/antinat-%{version}/version5/commands/libv5bind.so
%{_libdir}/antinat-%{version}/version5/commands/libv5ident.so
%{_libdir}/antinat-%{version}/resolvers/libipv4.so
%{_libdir}/antinat-%{version}/resolvers/libname.so
%{_libdir}/antinat-%{version}/revres/libipv4.so
%{_libdir}/antinat-%{version}/versions/libv5.so

%package socks4
Group: Daemons
Requires: antinat = %{version}
Summary: Support for SOCKS4 in antinat

%description socks4
Support for older style SOCKS4 connections in antinat.  SOCKS4 is limited
to anonymous only connections, and if authentication is required, do not
install this package.

%files socks4
%defattr(-,root,root)
%{_libdir}/antinat-%{version}/version4/*
%{_libdir}/antinat-%{version}/versions/libv4.so

%package logging
Group: Daemons
Requires: antinat = %{version}
Summary: Support for logging in antinat

%description logging
Support for connection and summary logging in antinat.

%files logging
%defattr(-,root,root)
%{_libdir}/antinat-%{version}/loggers/*
%{_localstatedir}

%package filtering
Group: Daemons
Requires: antinat = %{version}
Summary: Support for filtering in antinat

%description filtering
Support for allowing and disallowing connections on the basis of some
criteria in antinat.  Included are filters for IPv4 source and destination
addresses, as well as ports.

%files filtering
%defattr(-,root,root)
%{_libdir}/antinat-%{version}/filters/*

%package anonymous
Group: Daemons
Requires: antinat = %{version}
Summary: Support for anonymous SOCKS5 connections in antinat

%description anonymous
Support for anonymous (non-authenticated) connections in antinat.  If this
package is not installed, clients must give the username and password
credentials of a user on the server to proceed.  Note that socks4 will also
provide anonymous connections, in effect.

%files anonymous
%defattr(-,root,root)
%{_libdir}/antinat-%{version}/version5/authenticators/libanon.so

%package ipv6
Group: Daemons
Requires: antinat = %{version}
Summary: Support for IPv6 connections in antinat

%description ipv6
Support for IPv6 connections, to allow the server to connect to v6 hosts
and be connected to from v6 hosts.

%files ipv6
%defattr(-,root,root)
%{_libdir}/antinat-%{version}/address/libipv6_addr.so
%{_libdir}/antinat-%{version}/resolvers/libipv6.so
%{_libdir}/antinat-%{version}/revres/libipv6.so

%package udp
Group: Daemons
Requires: antinat = %{version}
Summary: Support for UDP Association in antinat

%description udp
Support for UDP association over SOCKSv5.  This allows hosts to send and
receive UDP packets through the SOCKS server.

%files udp
%defattr(-,root,root)
%{_libdir}/antinat-%{version}/version5/commands/libv5udp.so


