
#include "../config.h"
#include <DSHashTable.h>
#include "AddressInfo.h"
#include "address.h"
#include "moddecl.h"

extern DSHashTable addresses;

AddressInfo::AddressInfo(SOCKADDR * sa)
{
	nulladdr=TRUE;
	address_type=0;
	address=NULL;
	port=0;
	addrlen=0;
	setAddress(sa);
}


AddressInfo::~AddressInfo()
{
	if (address) free(address);
}

int AddressInfo::getAddressType()
{
	return address_type;
}

unsigned int AddressInfo::getPort()
{
	return port;
}

int AddressInfo::getAddressLength()
{
	return addrlen;
}

char * AddressInfo::getAddress()
{
	return address;
}

char * AddressInfo::getString()
{
	proc_getfunction gf;
	proc_getstring gs;
	gf=(proc_getfunction)addresses.getPtrValue(address_type);
	if (gf) {
		gs=(proc_getstring)gf(FUNC_GETSTRING);
		return gs(this);
	} else {
		return NULL;
	}
}

char * AddressInfo::getAddressString()
{
	proc_getfunction gf;
	proc_getstring gs;
	gf=(proc_getfunction)addresses.getPtrValue(address_type);
	if (gf) {
		gs=(proc_getstring)gf(FUNC_GETADDRSTRING);
		return gs(this);
	} else {
		return NULL;
	}
}
BOOL AddressInfo::getNullAddr()
{
	return nulladdr;
}

BOOL AddressInfo::getSockaddr(SOCKADDR ** sa, sl_t * len)
{
	proc_getfunction gf;
	proc_tosockaddr tsa;
	gf=(proc_getfunction)addresses.getPtrValue(address_type);
	if (gf) {
		tsa=(proc_tosockaddr)gf(FUNC_TOSOCKADDR);
		return tsa(this, sa, len);
	} else {
		return FALSE;
	}
}

BOOL AddressInfo::setAddress(SOCKADDR * sa)
{
	proc_getfunction gf;
	proc_fromsockaddr fsa;
	if (sa==NULL) return FALSE;
	gf=(proc_getfunction)addresses.getPtrValue(sa->sa_family);
	if (gf) {
		address_type=sa->sa_family;
		fsa=(proc_fromsockaddr)gf(FUNC_FROMSOCKADDR);
		return fsa(this, sa);
	} else {
		return FALSE;
	}
}

void AddressInfo::setAddressType(int newtype)
{
	address_type=newtype;
}

void AddressInfo::setPort(unsigned int newport)
{
	port=newport;
}

void AddressInfo::setAddress(char * newaddr,int newlen)
{
	int i;
	if (address) free(address);
	address=(char *)malloc(newlen);
	memcpy(address,newaddr,newlen);
	addrlen=newlen;
	nulladdr=FALSE;
	for (i=0;(address[i]==0)&&(i<newlen);i++);
	if (i>=newlen) nulladdr=TRUE;
}

