/* ANTINAT
 * =======
 * This software is Copyright (c) 2003 Malcolm Smith.
 * No warranty is provided, including but not limited to
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * This code is licenced subject to the GNU General
 * Public Licence (GPL).  See the COPYING file for more.
 */

#include "../../config.h"
#include <DSNetwork.h>
#include <DSMutex.h>
#ifdef HAVE_NETINET_IN_H
#include <netinet/in.h>
#endif
#ifdef HAVE_NETDB_H
#include <netdb.h>
#endif
#include "../Locks.h"
#include "../Connection.h"


extern "C" {
int libname_resolver_type()
{
	return 0x03;
}
}

BOOL resname_resolve(Connection * conn)
{
	unsigned char len;

	char * temp;
	char tmpPort[3];
	unsigned short port;

	conn->getChar(&len);

	/* getSlab null terminates */
	temp=(char *)malloc(len+1);
	conn->getSlab(temp, len);
#ifdef WITH_DEBUG
	printf("name trying to connect to %s\n",temp);
#endif
	conn->getSlab(tmpPort, 2);
	memcpy(&port,tmpPort,2);
	conn->setDestPort(port);
	if (!conn->setDestHostname(temp)) {
		free(temp);
		return FALSE;
	} else {
		free(temp);
		return TRUE;
	}
}

extern "C" {
BOOL libname_resolve(void * conn)
{
	return resname_resolve((Connection *)conn);
}
}

